package net.t2code.automatedMessages.config;

public enum Config {

    updateCheckOnJoin("plugin.updateCheck.onJoin", true, ConfigParam.BOOLEAN),
    updateCheckSeePreReleaseUpdates("plugin.updateCheck.seePreReleaseUpdates", true, ConfigParam.BOOLEAN),
    updateCheckTimeInterval("plugin.updateCheck.timeInterval", 60, ConfigParam.INTEGER),

    prefix("plugin.prefix", "<dark_gray>[<dark_red>T2C</dark_red>-<color:#5cff5c>Automated</color><color:#69d2ff>Messages</color>]</dark_gray>", ConfigParam.STRING),
    sendConsole("plugin.broadcastInConsole", true, ConfigParam.BOOLEAN),

    timeFormat("plugin.timeFormat", "HH:mm:ss yyyy/MM/dd", ConfigParam.STRING),

    msgReloadStart("plugin.messages.reloadStart", "[prefix] Reload starting...", ConfigParam.STRING),
    msgReloadEnd("plugin.messages.reloadEnd", "[prefix] Reload successful.", ConfigParam.STRING);


    public String path;
    public String valueString;
    public Boolean valueBoolean;
    public Integer valueInteger;
    public ConfigParam configParam;

    Config(String path, String value, ConfigParam cEnum) {
        this.path = path;
        this.valueString = value;
        this.configParam = cEnum;
    }

    Config(String path, Integer value, ConfigParam cEnum) {
        this.path = path;
        this.valueInteger = value;
        this.configParam = cEnum;
    }

    Config(String path, Boolean value, ConfigParam cEnum) {
        this.path = path;
        this.valueBoolean = value;
        this.configParam = cEnum;
    }
}
