package net.t2code.automatedMessages.config;

import net.t2code.automatedMessages.Util;
import net.t2code.automatedMessages.system.Main;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Creplace;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;
import java.util.Objects;

public class FileBuild {

    public static void selectConfig() {

        File config = new File(Main.getPath(), "config.yml");
        YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(config);
        for (Config value : Config.values()) {
            switch (value.configParam) {
                case STRING:
                    if (!yamlConfiguration.contains(value.path)) {
                        yamlConfiguration.set(value.path, value.valueString);
                    }
                    value.valueString = T2Creplace.replace(Util.getPrefix(), Objects.requireNonNull(yamlConfiguration.getString(value.path)));
                    break;
                case BOOLEAN:
                    if (!yamlConfiguration.contains(value.path)) {
                        yamlConfiguration.set(value.path, value.valueBoolean);
                    }
                    value.valueBoolean = yamlConfiguration.getBoolean(value.path);
                    break;

                case INTEGER:
                    if (!yamlConfiguration.contains(value.path)) {
                        yamlConfiguration.set(value.path, value.valueInteger);
                    }
                    value.valueInteger = yamlConfiguration.getInt(value.path);
                    break;
            }
        }
        try {
            yamlConfiguration.save(config);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
